using System;

namespace lliurex
{
	namespace zero
	{
		namespace serverwizard
		{
			public class IndependentServer : lliurex.zero.serverwizard.Server
			{
				private lliurex.zero.serverwizard.Core core;
				
				public IndependentServer ()
				{
					core=lliurex.zero.serverwizard.Core.getCore();
					kpassword="";
					core.debug("[IndependetServer] Loading LliureX variables");
					core.new_center_code=0;
					
					System.Collections.Generic.Dictionary <string,string> extra_llxvars ;
					extra_llxvars=new System.Collections.Generic.Dictionary<string, string>();
					extra_llxvars=lliurex.zero.serverwizard.Core.ListVars(Convert.ToString(core.new_center_code));
					
					foreach (System.Collections.Generic.KeyValuePair<string,string> item in extra_llxvars)
					{
						Console.WriteLine(item.Key + " " + item.Value);
						core.llxvars[item.Key]=item.Value;
					}
					
				}
				
				public override Gtk.Widget myNextStep()
				{
					switch(core.selected_option)
					{
						case 0: 
						
							// COMPLETE INSTALLATION
						
							switch (core.step)
							{
								case 1:		
									//CENTER CODE
									core.debug("[IndependentServer] Code Center is my current step");
									core.codecenter=new lliurex.zero.serverwizard.WidgetCodeCenter();
									// gui operations
									core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 2 of 5] Center Code</b>"));
									core.win.set_info_text(Mono.Unix.Catalog.GetString("Enter your Center Code"));
									core.win.image_1=core.codecenter.img_1;
									core.win.image_2=core.codecenter.img_2;
									return core.codecenter;
									
	
							
								case 2:
									// INTERNAL NET
									core.debug("[IndependentServer] Server Internal Network is my current step");
									core.serverNetwork=new lliurex.zero.serverwizard.WidgetServerNetwork();
									//core.serverExternalNetwork=null; // because i want to kill eth status check
									// gui operations
									core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 3 of 5] Internal Network Configuration</b>"));
									core.win.set_info_text(Mono.Unix.Catalog.GetString("Remember, these are only suggested values. Please check your network configuration."));
									// core.win.image_1= ENTER SOMETHING HERE;
									// core.win.image_2= ENTER SOMETHING HERE;
									return core.serverNetwork;	
							
							
							
								case 3:
									// EXTERNAL NET
									
									core.debug("[IndependentServer] Server External Network");
									core.serverExternalNetwork=new lliurex.zero.serverwizard.WidgetServerNetworkExternal();
									//gui operations
									core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 4 of 5] External Network Configuration</b>"));
									core.win.set_info_text(Mono.Unix.Catalog.GetString("If you are not sure of what to enter here, use DHCP"));
									//core.win.set_info_text("");
									// core.win.image_1= ENTER SOMETHING HERE;
									// core.win.image_2= ENTER SOMETHING HERE
									return core.serverExternalNetwork;
							
							
							
							/*
								case 4:
									core.debug("[IndependentServer] DNS Configuration is my current step");
									core.dns=new lliurex.zero.serverwizard.WidgetDNS();
									//gui operations
									core.win.set_label_text("<b>[Step 5 of ?] DNS Configuration</b>");
									core.win.set_info_text("Set primary and secondary DNS");
									
							
							
									return core.dns;
							*/
							
								case 4:
									// USER PASSWORD
									core.debug("[IndependentServer] User password is my current step");
									core.kpassword=new lliurex.zero.serverwizard.WidgetKerberosPassword();
									//gui operations
									core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 5 of 5] LDAP User Administratio password</b>"));
									core.win.set_info_text(Mono.Unix.Catalog.GetString("Enter your new LDAP Users administration password"));
							
									return core.kpassword;
							
								case 5:
									// END
									core.debug("[IndependentServer] Reset your computer is my next step");
									core.restart=new lliurex.zero.serverwizard.WidgetRestart();
									//gui operations
							
									core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[END] Restart your Computer</b>"));
									core.win.set_info_text(Mono.Unix.Catalog.GetString("Please check the values you just selected. If you are sure, press Accept."));
	
									// core.win.image_1= ENTER SOMETHING HERE;
									// core.win.image_2= ENTER SOMETHING HERE;
									
									return core.restart;
								
							
								default:
							
									return null;
							
							
							}
						
							// END CASE 0 : Complete Installation
						
												
						
						
							default:
						
								return null;
						
					}
				}
				
				public override void myNextAction()
				{
						
						//mynextStep+1
					
						switch (core.step)
						{
							case 1:
								//NOTHING
								break;
						
							case 2:
								core.debug("[IndependentServer] Action Step 2 - Save Code Center");
								//zero-server-wizard variables
								codeCenter=core.codecenter.codeCenter;
								//llxvars		
								core.llxvars["CODIGO_CENTRO"]=core.codecenter.codeCenter.ToString();
								break;
						

							case 3:
								core.debug("[IndependentServer] Action Step 3 - Save internal network data");
								//zero-server-wizard variables
								core.server.server_internal_device=core.serverNetwork.device;
								core.server.server_internal_ip=core.serverNetwork.ip;
								core.server.server_internal_mask=core.serverNetwork.mask;
								core.server.server_classroom_default=core.serverNetwork.default_values;
								//llxvars
								core.llxvars["SRV_IP"]=core.serverNetwork.ip;
								core.llxvars["SRV_MASK"]=core.serverNetwork.mask;
								break;						
						
						
							case 4:
								core.debug("[IndependentServer] Action Step 4 - Save external network data");
								//zero-server-wizard variables
								core.server.server_external_device=core.serverExternalNetwork.device;
								core.server.server_external_gateway=core.serverExternalNetwork.gateway;
								core.server.server_external_ip=core.serverExternalNetwork.ip;
								core.server.server_external_mask=core.serverExternalNetwork.mask;
								core.server.server_external_default=core.serverExternalNetwork.default_values;
								core.server.dns1=core.serverExternalNetwork.DNS1;
								core.server.dns_name_server1=core.serverExternalNetwork.NameServer;
								core.server.routing_enabled=core.serverExternalNetwork.routing;
								core.server.nat_enabled=core.serverExternalNetwork.nat;
								//llxvars
								core.llxvars["SRV_NIC_EXTERNAL"]=core.server.server_external_device;
								core.llxvars["DNS_EXTRA_NS"]=core.serverExternalNetwork.DNS1;
								core.llxvars["DNS_EXTRA_DOMAINS"]=core.serverExternalNetwork.NameServer;
						
								break;
						
						
							case 5:
								core.debug("[IndependentServer] Action Step 5 - User Password");
								//zero-server-wizard variables
								kpassword=core.kpassword.kpassword;
						
								break;
						
						
							default:
								//NOTHING
								break;
						
						}
					
				}
			}
		}
	}
}