using System;

namespace lliurex
{
	namespace zero
	{
		namespace serverwizard
		{
			public class IntegratedServer : lliurex.zero.serverwizard.Server
			{
				private lliurex.zero.serverwizard.Core core;
				public string master_ip;
				public string master_user;
				public string master_password;
				
				public IntegratedServer ()
				{
					master_ip="";
					master_user="";
					master_password="";
					core=lliurex.zero.serverwizard.Core.getCore();
					core.debug("[IntegratedServer] Loading LliureX variables");
					System.Collections.Generic.Dictionary <string,string> extra_llxvars ;
					extra_llxvars=new System.Collections.Generic.Dictionary<string, string>();
					extra_llxvars=lliurex.zero.serverwizard.Core.ListVars(Convert.ToString(core.new_center_code));
					
					
					
					foreach (System.Collections.Generic.KeyValuePair<string,string> item in extra_llxvars)
					{
						Console.WriteLine(item.Key + " " + item.Value);
						core.llxvars[item.Key]=item.Value;
					}
					
				}
				public override Gtk.Widget myNextStep()
				{
						switch (core.step)
						{
						
							case 1:
								core.debug("[IntegratedServer] Center Code and ID is my current step");
								core.codecenter=new lliurex.zero.serverwizard.WidgetCodeCenter();
						
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 2 of 7] Code center</b>"));		
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Enter your Center Code"));
						
								return core.codecenter;
						
						
							case 2:
								core.debug("[IntegratedServer] Master Info is my current step");
								core.masterserver=new lliurex.zero.serverwizard.WidgetMasterServer();
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 3 of 7] Master Server Info</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Enter your Master CAP Server."));
							//	core.win.image_1=core.codecenter.img_1;
							//	core.win.image_2=core.codecenter.img_2;
								return core.masterserver;
						
						
							case 3:
								core.debug("[IntegratedServer] Integrated Internal Network Device is my current step");
								core.serverNetwork=new lliurex.zero.serverwizard.WidgetServerNetwork();
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 4 of 7] Integrated Server Internal Network Device</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Remember, these are only suggested values. Please check your network configuration."));
								//
								return core.serverNetwork;
						
						
							case 4:
								core.debug("[IntegratedServer] Integrated External Network Device is my current step");
								core.serverExternalNetwork=new lliurex.zero.serverwizard.WidgetServerNetworkExternal();
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 5 of 7] Integrated Server External Network Device</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("If you are not sure of what to enter here, use DHCP"));
						
								//
								return core.serverExternalNetwork;
						

							case 5:
								core.debug("[IntegratedServer] Management Network is my current step");
				
								core.mgnnetwork = new lliurex.zero.serverwizard.WidgetManagementNetwork();
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 6 of 7] Network Management</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Enter your Management Network Info."));
								// core.win.image_1= ENTER SOMETHING HERE;
								// core.win.image_2= ENTER SOMETHING HERE;
								return core.mgnnetwork;		
						
						
							case 6:
								core.debug("[IntegratedServer] END");
								core.restart=new lliurex.zero.serverwizard.WidgetRestart();
								// gui operations
						
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 7 of 7] Reboot your system</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Please check the values you just selected. If you are sure, press Accept."));
						
								
								return core.restart;
							
							default:
								return null;
												
						}
						
					
				}
				
				public override void myNextAction()
				{
						
						//mynextStep+1
					
						switch (core.step)
						{
							case 1:
								core.debug("[IntegratedServer] Action Step 1 - Do Nothing");
							
								break;
						
						
							case 2:
								core.debug("[IntegratedServer] Action Step 2 - Saving Center Code");
								//zero-server-wizard variables
								codeCenter=core.codecenter.codeCenter;
								
								//llxvars								
								core.llxvars["CODIGO_CENTRO"]=core.codecenter.codeCenter.ToString();						
								break;
						
							case 3:
								core.debug("[IntegratedServer] Action Step 3 - Saving Master Server info");
								this.master_ip=core.masterserver.MasterIP;
								this.master_user=core.masterserver.User;
								this.master_password=core.masterserver.Password;
						
								//Console.WriteLine("> " + this.master_ip + " " + this.master_user + " " + this.master_password);
						
						
								break;
						

						
						
							case 4:
								core.debug("[IntegratedServer] Action Step 4 - Saving internal network device");
								//zero-server-wizard variables
								core.server.server_internal_device=core.serverNetwork.device;
								core.server.server_internal_ip=core.serverNetwork.ip;
								core.server.server_internal_mask=core.serverNetwork.mask;
								core.server.server_classroom_default=core.serverNetwork.default_values;
								//llxvars
								core.llxvars["SRV_IP"]=core.serverNetwork.ip;
								core.llxvars["SRV_MASK"]=core.serverNetwork.mask;
								break;	
						
						
							case 5:
								
								core.debug("[IntegratedServer] Action Step 5 - Saving external network device");
								//zero-server-wizard variables
								core.server.server_external_device=core.serverExternalNetwork.device;
								core.server.server_external_gateway=core.serverExternalNetwork.gateway;
								core.server.server_external_ip=core.serverExternalNetwork.ip;
								core.server.server_external_mask=core.serverExternalNetwork.mask;
								core.server.server_external_default=core.serverExternalNetwork.default_values;
								core.server.dns1=core.serverExternalNetwork.DNS1;
								core.server.dns_name_server1=core.serverExternalNetwork.NameServer;
								core.server.routing_enabled=core.serverExternalNetwork.routing;
								core.server.nat_enabled=core.serverExternalNetwork.nat;
								//llxvars
								core.llxvars["SRV_NIC_EXTERNAL"]=core.server.server_external_device;
								core.llxvars["DNS_EXTRA_NS"]=core.serverExternalNetwork.DNS1;
								core.llxvars["DNS_EXTRA_DOMAINS"]=core.serverExternalNetwork.NameServer;
								break;
						
							case 6:
						
								core.debug("[MainServer] Action Step 6 - Save Management Network");
								//zero-server-wizard variables
								mng_network=core.mgnnetwork.ip;
								iface=core.mgnnetwork.device;
								//llxvars
								core.llxvars["MNG_IP"]=core.mgnnetwork.ip;
								break;				
						
						
								
						

							default:
								core.debug("[IntegratedServer] Action default - Do nothing");
								break;
		
											
						}

				}
							
				

			}
		}
	}
}
