
using System;

namespace lliurex
{
	namespace zero
	{
		namespace serverwizard
		{
			public class MainServer : lliurex.zero.serverwizard.Server
			{

				public lliurex.zero.serverwizard.Core core;
			

				
				public MainServer ()
				{
					core=lliurex.zero.serverwizard.Core.getCore();
					core.new_center_code=254;
					core.debug("[MainServer] Refreshing LliureX variables");
					System.Collections.Generic.Dictionary <string,string> extra_llxvars ;
					extra_llxvars=new System.Collections.Generic.Dictionary<string, string>();
					extra_llxvars=lliurex.zero.serverwizard.Core.ListVars(Convert.ToString(core.new_center_code));
					
					foreach (System.Collections.Generic.KeyValuePair<string,string> item in extra_llxvars)
					{
						Console.WriteLine(item.Key + " " + item.Value);
						core.llxvars[item.Key]=item.Value;
					}
					
					

				}
				
				
				
				
				
				/*
				public int codeCenter
				{
					set
					{
						code_center=value;	
						
					}
					get
					{
						return code_center;
							
					}
					
					
				}*/
				
				public override Gtk.Widget myNextStep()
				{
						switch (core.step)
						{
							case 1:
								core.debug("[MainServer] Code Center is my current step");
								core.codecenter=new lliurex.zero.serverwizard.WidgetCodeCenter();
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 2 of 6] Center Code</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Enter your Center Code"));
								core.win.image_1=core.codecenter.img_1;
								core.win.image_2=core.codecenter.img_2;
								return core.codecenter;

						
						
							case 2:
								core.debug("[MainServer] Server Internal Network is my current step");
								core.serverNetwork=new lliurex.zero.serverwizard.WidgetServerNetwork();
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 3 of 6] Internal Network Configuration</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Remember, these are only suggested values. Please check your network configuration."));
								// core.win.image_1= ENTER SOMETHING HERE;
								// core.win.image_2= ENTER SOMETHING HERE;
								return core.serverNetwork;	
						
						
							case 3:
						
								core.debug("[MainServer] Server External Network");
								core.serverExternalNetwork=new lliurex.zero.serverwizard.WidgetServerNetworkExternal();
								
								//gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 4 of 6] External Network Configuration</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("If you are not sure of what to enter here, use DHCP"));
						
								
						
								//core.win.set_info_text("");
								// core.win.image_1= ENTER SOMETHING HERE;
								// core.win.image_2= ENTER SOMETHING HERE
								return core.serverExternalNetwork;
						

						

						
							case 4:
								core.debug("[MainServer] Management Network is my current step");
								core.mgnnetwork = new lliurex.zero.serverwizard.WidgetManagementNetwork();
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 5 of 6] Network Management</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Enter your Management Network Info."));
								// core.win.image_1= ENTER SOMETHING HERE;
								// core.win.image_2= ENTER SOMETHING HERE;
								return core.mgnnetwork;
						
						
							case 5:
								core.debug("[MainServer] User password is my current step");
								core.kpassword=new lliurex.zero.serverwizard.WidgetKerberosPassword();
								// gui operations
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 6 of 6] Reset your User Password</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Enter your new administration password"));
						
								
								return core.kpassword;
						
							case 6:
								core.debug("[MainServer] Reset your computer is my next step");
								core.restart=new lliurex.zero.serverwizard.WidgetRestart();
								//gui operations
						
								core.win.set_label_text(Mono.Unix.Catalog.GetString("<b>[END] Review and execute</b>"));
								core.win.set_info_text(Mono.Unix.Catalog.GetString("Please check the values you just selected. If you are sure, press Accept."));

								// core.win.image_1= ENTER SOMETHING HERE;
								// core.win.image_2= ENTER SOMETHING HERE;
								
								return core.restart;
						
								
						
						
							
							default:
								return null;
												
						}
						
					
				}
				
				public override void myNextAction()
				{
						
						//mynextStep+1
					
						switch (core.step)
						{
							case 1:
								core.debug("[MainServer] Action Step 1 - Do Nothing");
								break;
						
							case 2:
								core.debug("[MainServer] Action Step 2 - Save Code Center");
								//zero-server-wizard variables
								codeCenter=core.codecenter.codeCenter;
								
								//llxvars								
								//core.llxvars["CODIGO_CENTRO"]=core.codecenter.codeCenter.ToString();
								break;
						/*
							case 3:
								core.debug("[MainServer] Action Step 3 - Save CAP Code");
								//zero-server-wizard variables
								cap_code=core.capcode.CAPCode;
							
								break;
						*/
						

						
							case 3:
								core.debug("[MainServer] Action Step 3 - Save internal network data");
								//zero-server-wizard variables
								core.server.server_internal_device=core.serverNetwork.device;
								core.server.server_internal_ip=core.serverNetwork.ip;
								core.server.server_internal_mask=core.serverNetwork.mask;
								core.server.server_classroom_default=core.serverNetwork.default_values;
								//llxvars
						
											
								break;
						
							case 4:
								core.debug("[MainServer] Action Step 4 - Save external network data");
								//zero-server-wizard variables
								core.server.server_external_device=core.serverExternalNetwork.device;
								core.server.server_external_gateway=core.serverExternalNetwork.gateway;
								core.server.server_external_ip=core.serverExternalNetwork.ip;
								core.server.server_external_mask=core.serverExternalNetwork.mask;
								core.server.server_external_default=core.serverExternalNetwork.default_values;
								core.server.routing_enabled=core.serverExternalNetwork.routing;
								core.server.nat_enabled=core.serverExternalNetwork.nat;
								//llxvars
								core.llxvars["SRV_NIC_EXTERNAL"]=core.server.server_external_device;
								core.llxvars["DNS_EXTRA_NS"]=core.serverExternalNetwork.DNS1;
								core.llxvars["DNS_EXTRA_DOMAINS"]=core.serverExternalNetwork.NameServer;
						
					
						
								break;
						
							case 5:
								core.debug("[MainServer] Action Step 5 - Save Management Network");
								//zero-server-wizard variables
								mng_network=core.mgnnetwork.ip;
								iface=core.mgnnetwork.device;
								//llxvars
								core.llxvars["MNG_IP"]=core.mgnnetwork.ip;
								break;
							
							case 6:
								core.debug("[MainServer] Action Step 6 - Save user password");
								kpassword=core.kpassword.kpassword;
								break;
						
							default:
								core.debug("[MainServer] Action default - Do nothing");
								break;
		
											
						}

				}
			}
				
				
		}
	}
}

