using System;
using Gtk;

public partial class MainWindow : Gtk.Window
{
	public lliurex.zero.serverwizard.Core core; 
	
	public Gtk.Widget current;
	
	private bool enabledButtons;
	
	public string image_1;
	public string image_2;
	
	public bool image_selection;
	
	public MainWindow () : base(Gtk.WindowType.Toplevel)
	{
		Build ();
		
		
		core = lliurex.zero.serverwizard.Core.getCore();
		core.welcome=new lliurex.zero.serverwizard.WidgetWelcome();
		

		
		current=core.welcome;
		mainAlignement.Add(current);
		current.Show();
		textviewInfo.Sensitive=false;
		image_selection=false;
		
		image_1=core.welcome.icon1;
		image_2=core.welcome.icon2;
		enabledButtons=true;
		
		set_info_text(core.welcome.info_msg);
		if(!core.nomorethreads)
		{
			//System.Threading.ThreadStart starter= delegate {GLib.Timeout.Add(700,new GLib.TimeoutHandler(set_animation)); };;
			//new System.Threading.Thread(starter).Start();
			GLib.Timeout.Add(700,new GLib.TimeoutHandler(set_animation));
			
			
			core.nomorethreads=true;	
		}
		
		

		
	}
	
	public bool set_animation()
	{
	
		
		if (image_selection)
		{
			set_image_help(image_1);
			image_selection=false;
		//	Console.WriteLine("1");
		}
		else
		{
			set_image_help(image_2);		
			image_selection=true;
		//	Console.WriteLine("2");
		}
		
		
		return true;
	}
	
	public void set_label_text(string state)
	{
		//lblState.Text=state;	
		//lblState.Markup=state;
		GtkFrameLabel.Markup=state;
	}
	
	public void set_warning_text(string state)
	{
		
		lblMsg.Markup="<span foreground='red'>" + state + "</span>";	
	}
	
	public string warning
	{
		get
		{
			return lblMsg.Text;	
		}
		
	}
	
	public string closeButtonText
	{
		set
		{
			btnClose.Label=value;
		}
	}
	
	
	public void set_image_help(string pixbuf)
	{
		imageDiagram.PixbufAnimation = Gdk.PixbufAnimation.LoadFromResource(pixbuf);
		
	}
	
	public bool enabled_buttons
	{
		get	
		{
			return enabledButtons;	
		}
		
		set
		{
			enabledButtons=value;
			
			btnClose.Sensitive=value;
			btnNext.Sensitive=value;
			btnPrevious.Sensitive=value;
			
		}
		
	}
	
	public bool buttonNextEnabled
	{
		get
		{
			return btnNext.Sensitive;	
		}
		set
		{
			btnNext.Sensitive=value;
		}
	}
	
	
	public void set_info_text(string state)
	{
		string tmp=Mono.Unix.Catalog.GetString("Important:\n") + state;
		textviewInfo.Buffer.Text=tmp;
		
	}
	

	public void swapWidget()
	{
		/**
		 * Change between diferent widets
		 * 
		 * STEP 0 = Welcome
		 * STEP 1 = Codecenter
		 * STEP 2 = 
		 **/
		
		// Ask for next step here
		
		Gtk.Widget toBeDrawn=null;
		
		
		if (core.step>0)
		{
			core.server.myNextAction();	
			toBeDrawn=core.server.myNextStep();
			
		}
		else
		{
					
			toBeDrawn=core.welcome;
			set_info_text(core.welcome.info_msg);
			set_label_text(Mono.Unix.Catalog.GetString("<b>[Step 1] Server Selection</b>"));
			image_1=core.welcome.icon1;
			image_2=core.welcome.icon2;
			
		}	
			
		if(toBeDrawn!=null)
		{			
			toBeDrawn.Show();
		
			mainAlignement.Remove(current);
			 
			current=toBeDrawn;
		
			mainAlignement.Add(toBeDrawn);
		}
		else
			core.step--;
	

		
	
			
		
		
	}
	
	
	protected void OnDeleteEvent (object sender, DeleteEventArgs a)
	{
		Application.Quit ();
		a.RetVal = true;
	}
	
	
	protected virtual void OnBtnNextClicked (object sender, System.EventArgs e)
	{
		
		core.debug(core.step.ToString());
		//core.welcome.radioButtonIndependent
	
		string _debug=core.welcome.ServerType.ToString();
		
		core.debug("[MainWindow] SERVER TYPE " + _debug);
		
		
		
		if (core.step==0)
		{
			
			if((core.welcome.CenterNode!=-1 && core.welcome.ServerType==2)||(core.welcome.ServerType==1 || core.welcome.ServerType==3))
			{
				switch (core.welcome.ServerType)
				{
					case 1:	
							if (!(core.server is lliurex.zero.serverwizard.MainServer))
							{
					    		core.server=new lliurex.zero.serverwizard.MainServer();
								core.debug("[MainWindow] Main Server selected");
								core.selected_option=((lliurex.zero.serverwizard.WidgetMainServerOptions)core.welcome.current_option).type;
								core.debug("[MainWindow] Main Server Installation type: " + Convert.ToString(core.selected_option));
							}
							else
							{
								core.selected_option=((lliurex.zero.serverwizard.WidgetMainServerOptions)core.welcome.current_option).type;
								core.debug("[MainWindow] Main Server Installation type: " + Convert.ToString(core.selected_option));					
							}
							
							break;
					case 2:
							if (!(core.server is lliurex.zero.serverwizard.IntegratedServer))
							{
								core.server=new lliurex.zero.serverwizard.IntegratedServer();
								core.debug("[MainWindow] Integrated Server selected");
							}
							else
							{
						
							}
							break;
					case 3:
							if (!(core.server is lliurex.zero.serverwizard.IndependentServer))
							{
								core.server=new lliurex.zero.serverwizard.IndependentServer();
	
								core.debug("[MainWindow] Independent Server selected");
								core.selected_option=((lliurex.zero.serverwizard.WidgetIndependentOptions)core.welcome.current_option).type;
								core.debug("[MainWindow] Independent Server Installation type: " + Convert.ToString(core.selected_option));
							}
							else
							{
								core.selected_option=((lliurex.zero.serverwizard.WidgetIndependentOptions)core.welcome.current_option).type;
								core.debug("[MainWindow] Independent Server Installation type: " + Convert.ToString(core.selected_option));
						
						
							}
							break;
					case 0:
							core.debug("[MainWindow] No server type selected");
							break;
					
				}
			}
			else
			{
			
				core.win.set_warning_text(Mono.Unix.Catalog.GetString("You must enter a Classroom ID"));
				
			}
		}
		
		if((core.welcome.CenterNode!=-1 && core.welcome.ServerType==2) ||(core.welcome.ServerType==1 || core.welcome.ServerType==3))
		{
			core.step++;
			swapWidget();
		}
		
		

		
		/*about=new lliurex.zero.serverwizard.WidgetAbout();
		MainVBox.Add(about);
		about.Show();*/
	}
	
	protected virtual void OnBtnCloseClicked (object sender, System.EventArgs e)
	{
		Application.Quit();
	}
	
	protected virtual void OnBtnPreviousClicked (object sender, System.EventArgs e)
	{
		if (core.step==0)
		{
			switch (core.welcome.ServerType)
			{
				case 1:	
						if (!(core.server is lliurex.zero.serverwizard.MainServer))
						{
				    		core.server=new lliurex.zero.serverwizard.MainServer();
							core.debug("[MainWindow] Main Server selected");

						}
						
						break;
				case 2:
						if (!(core.server is lliurex.zero.serverwizard.IntegratedServer))
						{
							core.server=new lliurex.zero.serverwizard.IntegratedServer();
							core.debug("[MainWindow] Integrated Server selected");
						}
						break;
				case 3:
						if (!(core.server is lliurex.zero.serverwizard.IndependentServer))
						{
							core.server=new lliurex.zero.serverwizard.IndependentServer();

							core.debug("[MainWindow] Independent Server selected");
						}
						break;
				case 0:
						core.debug("[MainWindow] No server type selected");
						break;
				
			}
		}
		if(core.step>0)
		{
			core.step--;
			core.win.set_warning_text("");	
			
		}
		
		buttonNextEnabled=true;
		
		swapWidget();
	}
	
	
	
	
}
