
using System;

namespace lliurex
{
	namespace zero
	{
		namespace serverwizard
		{


	[System.ComponentModel.ToolboxItem(true)]
	public partial class WidgetWelcome : Gtk.Bin
	{

		public Gtk.Widget current_option;
		public string info_msg;
				
		public string icon1="zeroserverwizard.rsrc.welcome1.png";
		public string icon2="zeroserverwizard.rsrc.welcome2.png";
				
		public bool noneConfigurated;
				
		public WidgetWelcome ()
		{
			this.Build ();
			info_msg=Mono.Unix.Catalog.GetString("Please select your server type.\n");

			bool dont=false;
					

			lliurex.zero.serverwizard.Core core = lliurex.zero.serverwizard.Core.getCore();
			
			if(core.llxvars.ContainsKey("SRV_HOST_ID"))
			{
				entryCenterNode.Text=core.llxvars["SRV_HOST_ID"];
						
				try
				{
					Convert.ToInt32(core.llxvars["SRV_HOST_ID"]);		
					core.debug("[WidgetWelcome] Center node = " + core.llxvars["SRV_HOST_ID"] );
					noneConfigurated=false;
					core.old_center_code=Convert.ToInt32(core.llxvars["SRV_HOST_ID"]);	
					core.new_center_code=core.old_center_code;
					int tmp_host_id=Convert.ToInt32(core.llxvars["SRV_HOST_ID"]);
					
					if (tmp_host_id==254)
					{
						set_selected_option(0);
								
						core.msoptions=new lliurex.zero.serverwizard.WidgetMainServerOptions();
						current_option=core.msoptions;
						mainHbox.Add(current_option);
						mainHbox.ShowAll();
						
					}
					if (tmp_host_id>0 && tmp_host_id<254)
					{
								
						set_selected_option(1);
						/*		
						core.intoptions=new lliurex.zero.serverwizard.WidgetIntegratedOptions();
						current_option=core.intoptions;
						mainHbox.Add(current_option);
						mainHbox.ShowAll();
						*/
						dont=true;
					}
					if (tmp_host_id==0)
					{
						set_selected_option(2);
						/*		
						core.indoptions=new lliurex.zero.serverwizard.WidgetIndependentOptions();
						current_option=core.indoptions;
						mainHbox.Add(current_option);
						mainHbox.ShowAll();
						*/
					}
				}
				catch
				{
					core.debug("[WidgetWelcome] CENTER NODE needs to be configurated");
					noneConfigurated=true;
					core.old_center_code=-1;
					set_selected_option(0);
								
					core.msoptions=new lliurex.zero.serverwizard.WidgetMainServerOptions();
					current_option=core.msoptions;
					mainHbox.Add(current_option);
					mainHbox.ShowAll();					
					
				}
						
			}
			else
			{
				core.old_center_code=-1;
				set_selected_option(0);
				core.msoptions=new lliurex.zero.serverwizard.WidgetMainServerOptions();
				current_option=core.msoptions;
				mainHbox.Add(current_option);
				mainHbox.ShowAll();			
			}
					

			if(!dont)
			{
				labelCenterNode.Sensitive=false;
				entryCenterNode.Sensitive=false;
			}					
					
		}
				
	
		public void set_selected_option(int op)
		{
			switch(op)
			{
					case 0: // MainServer
						
						radiobuttonMainServer.Active=true;
						
						break;
						
					case 1: // Integrated server
						
						radiobuttonIntegratedServer.Active=true;
						
						break;
						
					case 2: // Independent Server
						
						radiobuttonIndependent.Active=true;
						
						break;
						
					default:
						
						radiobuttonMainServer.Active=true;
						
						break;
						
			}
		}
				
				
		public int CenterNode
		{
			get
			{
				int tmp=-1;
				try
				{
					tmp=Convert.ToInt32(entryCenterNode.Text);		
							
				}
				catch
				{
					tmp=-1;			
				}
				return tmp;
						
			}
					
		}
				
		public int ServerType
		{
			get
					{
						if (radiobuttonIndependent.Active)
							return 3;
						else
							if (radiobuttonIntegratedServer.Active)
								return 2;
							else 
								if (radiobuttonMainServer.Active)
									return 1;
								else
									return 0;
					}
			
		}
				
		protected virtual void OnRadiobuttonMainServerToggled (object sender, System.EventArgs e)
		{
			if (radiobuttonMainServer.Active)
			{	
				lliurex.zero.serverwizard.Core.getCore().debug("[WidgetWelcome] Main Server");		
				lliurex.zero.serverwizard.Core.getCore().new_center_code=254;		
				if(current_option!=null)
					mainHbox.Remove(current_option);
				lliurex.zero.serverwizard.Core.getCore().msoptions=new lliurex.zero.serverwizard.WidgetMainServerOptions();
				current_option=lliurex.zero.serverwizard.Core.getCore().msoptions;
				mainHbox.Add(current_option);
				mainHbox.ShowAll();	
				labelCenterNode.Sensitive=false;
				entryCenterNode.Sensitive=false;
						
				if(lliurex.zero.serverwizard.Core.getCore().win!=null)
				{
					lliurex.zero.serverwizard.Core.getCore().win.buttonNextEnabled=true;
					lliurex.zero.serverwizard.Core.getCore().win.set_warning_text("");
				}
			}
		}
		
		protected virtual void OnRadiobuttonIntegratedServerToggled (object sender, System.EventArgs e)
		{
			if (radiobuttonIntegratedServer.Active)
			{	
				lliurex.zero.serverwizard.Core.getCore().debug("[WidgetWelcome] Integrated Server");
				lliurex.zero.serverwizard.Core.getCore().new_center_code=CenterNode;		
				if(current_option!=null)
					mainHbox.Remove(current_option);
				lliurex.zero.serverwizard.Core.getCore().intoptions=new lliurex.zero.serverwizard.WidgetIntegratedOptions();
				current_option=lliurex.zero.serverwizard.Core.getCore().intoptions;
				mainHbox.Add(current_option);
				mainHbox.ShowAll();	
				labelCenterNode.Sensitive=true;
				entryCenterNode.Sensitive=true;
				
				if(entryCenterNode.Text=="" && lliurex.zero.serverwizard.Core.getCore().win!=null)
				{
					lliurex.zero.serverwizard.Core.getCore().win.buttonNextEnabled=false;
					lliurex.zero.serverwizard.Core.getCore().win.set_warning_text(Mono.Unix.Catalog.GetString("You must enter a Classroom ID"));
											
				}
				if (CenterNode > 253 || CenterNode < 1)
				{
					lliurex.zero.serverwizard.Core.getCore().win.set_warning_text(Mono.Unix.Catalog.GetString("Classroom ID must be an integer between 1 and 253"));
					lliurex.zero.serverwizard.Core.getCore().win.buttonNextEnabled=false;					
							
				}
			}
		}
		
		protected virtual void OnRadiobuttonIndependentToggled (object sender, System.EventArgs e)
		{
			if (radiobuttonIndependent.Active)
			{	
				lliurex.zero.serverwizard.Core.getCore().debug("[WidgetWelcome] Independent Server");		
				lliurex.zero.serverwizard.Core.getCore().new_center_code=0;		
				if(current_option!=null)
					mainHbox.Remove(current_option);
						
				lliurex.zero.serverwizard.Core.getCore().indoptions=new lliurex.zero.serverwizard.WidgetIndependentOptions();
				current_option=lliurex.zero.serverwizard.Core.getCore().indoptions;
				mainHbox.Add(current_option);
				mainHbox.ShowAll();	
						
				labelCenterNode.Sensitive=false;
				entryCenterNode.Sensitive=false;
				if (lliurex.zero.serverwizard.Core.getCore().win!=null)
				{
					lliurex.zero.serverwizard.Core.getCore().win.buttonNextEnabled=true;
					lliurex.zero.serverwizard.Core.getCore().win.set_warning_text("");
				}
			}
		}
		
		protected virtual void OnEntryCenterNodeChanged (object sender, System.EventArgs e)
		{
			System.Text.RegularExpressions.Regex regex=new System.Text.RegularExpressions.Regex("[^0-9]");	
					
					
					
			if(ServerType==2)
			{
				int tmp=254;
									
				try
				{
					tmp=Convert.ToInt32(entryCenterNode.Text);		
				}
				catch
				{
					tmp=254;	
				}
						
				if((entryCenterNode.Text!="" && regex.IsMatch(entryCenterNode.Text)) || tmp>253 || tmp<1)
				{
				
					lliurex.zero.serverwizard.Core.getCore().win.set_warning_text(Mono.Unix.Catalog.GetString("Classroom ID must be an integer between 1 and 253"));
					lliurex.zero.serverwizard.Core.getCore().win.buttonNextEnabled=false;	
				}
				else
				{
					lliurex.zero.serverwizard.Core.getCore().win.set_warning_text("");
					lliurex.zero.serverwizard.Core.getCore().win.buttonNextEnabled=true;
					lliurex.zero.serverwizard.Core.getCore().new_center_code=tmp;
					if (current_option is lliurex.zero.serverwizard.WidgetIntegratedOptions)
						((lliurex.zero.serverwizard.WidgetIntegratedOptions)current_option).update_sensitive();
					
				}
			}		
					
		}
		
		
		
		

		

		
		
		

		
		

		
		

		
		
				
	}
}
}
}
